Index: src/config.cpp
===================================================================
--- src/config.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/config.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -726,5 +729,5 @@
       bool status = true;
       while (status) {
-        Log() << Verbose(0) << "Currently parsing MD step " << repetition << "." << endl;
+        DoLog(0) && (Log() << Verbose(0) << "Currently parsing MD step " << repetition << "." << endl);
         for (int i=0; i < MaxTypes; i++) {
           sprintf(name,"Ion_Type%i",i+1);
@@ -732,5 +735,5 @@
             sprintf(keyword,"%s_%i",name, j+1);
             if (repetition == 0) {
-              neues = new atom();
+              neues = World::getInstance().createAtom();
               AtomList[i][j] = neues;
               LinearList[ FileBuffer->LineMapping[FileBuffer->CurrentLine] ] = neues;
@@ -739,7 +742,7 @@
               neues = AtomList[i][j];
             status = (status &&
-                    ParseForParameter(verbose,FileBuffer, keyword, 0, 1, 1, double_type, &neues->x.x[0], 1, (repetition == 0) ? critical : optional) &&
-                    ParseForParameter(verbose,FileBuffer, keyword, 0, 2, 1, double_type, &neues->x.x[1], 1, (repetition == 0) ? critical : optional) &&
-                    ParseForParameter(verbose,FileBuffer, keyword, 0, 3, 1, double_type, &neues->x.x[2], 1, (repetition == 0) ? critical : optional) &&
+                    ParseForParameter(verbose,FileBuffer, keyword, 0, 1, 1, double_type, &neues->x[0], 1, (repetition == 0) ? critical : optional) &&
+                    ParseForParameter(verbose,FileBuffer, keyword, 0, 2, 1, double_type, &neues->x[1], 1, (repetition == 0) ? critical : optional) &&
+                    ParseForParameter(verbose,FileBuffer, keyword, 0, 3, 1, double_type, &neues->x[2], 1, (repetition == 0) ? critical : optional) &&
                     ParseForParameter(verbose,FileBuffer, keyword, 0, 4, 1, int_type, &neues->FixedIon, 1, (repetition == 0) ? critical : optional));
             if (!status) break;
@@ -755,15 +758,15 @@
             // put into trajectories list
             for (int d=0;d<NDIM;d++)
-              neues->Trajectory.R.at(repetition).x[d] = neues->x.x[d];
+              neues->Trajectory.R.at(repetition)[d] = neues->x[d];
 
             // parse velocities if present
-            if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 5, 1, double_type, &neues->v.x[0], 1,optional))
-              neues->v.x[0] = 0.;
-            if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 6, 1, double_type, &neues->v.x[1], 1,optional))
-              neues->v.x[1] = 0.;
-            if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 7, 1, double_type, &neues->v.x[2], 1,optional))
-              neues->v.x[2] = 0.;
+            if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 5, 1, double_type, &neues->v[0], 1,optional))
+              neues->v[0] = 0.;
+            if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 6, 1, double_type, &neues->v[1], 1,optional))
+              neues->v[1] = 0.;
+            if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 7, 1, double_type, &neues->v[2], 1,optional))
+              neues->v[2] = 0.;
             for (int d=0;d<NDIM;d++)
-              neues->Trajectory.U.at(repetition).x[d] = neues->v.x[d];
+              neues->Trajectory.U.at(repetition)[d] = neues->v[d];
 
             // parse forces if present
@@ -775,5 +778,5 @@
               value[2] = 0.;
             for (int d=0;d<NDIM;d++)
-              neues->Trajectory.F.at(repetition).x[d] = value[d];
+              neues->Trajectory.F.at(repetition)[d] = value[d];
 
   //            Log() << Verbose(0) << "Parsed position of step " << (repetition) << ": (";
@@ -792,5 +795,5 @@
       }
       repetition--;
-      Log() << Verbose(0) << "Found " << repetition << " trajectory steps." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Found " << repetition << " trajectory steps." << endl);
       if (repetition <= 1)  // if onyl one step, desactivate use of trajectories
         mol->MDSteps = 0;
@@ -804,5 +807,5 @@
               ParseForParameter(verbose,FileBuffer, "Ion_Type1_1", 0, 3, 1, double_type, &value[2], repetition, (repetition == 0) ? critical : optional))
         repetition++;
-      Log() << Verbose(0) << "I found " << repetition << " times the keyword Ion_Type1_1." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "I found " << repetition << " times the keyword Ion_Type1_1." << endl);
       // parse in molecule coordinates
       for (int i=0; i < MaxTypes; i++) {
@@ -811,5 +814,5 @@
           sprintf(keyword,"%s_%i",name, j+1);
           if (repetition == 0) {
-            neues = new atom();
+            neues = World::getInstance().createAtom();
             AtomList[i][j] = neues;
             LinearList[ FileBuffer->LineMapping[FileBuffer->CurrentLine] ] = neues;
@@ -818,14 +821,14 @@
             neues = AtomList[i][j];
           // then parse for each atom the coordinates as often as present
-          ParseForParameter(verbose,FileBuffer, keyword, 0, 1, 1, double_type, &neues->x.x[0], repetition,critical);
-          ParseForParameter(verbose,FileBuffer, keyword, 0, 2, 1, double_type, &neues->x.x[1], repetition,critical);
-          ParseForParameter(verbose,FileBuffer, keyword, 0, 3, 1, double_type, &neues->x.x[2], repetition,critical);
+          ParseForParameter(verbose,FileBuffer, keyword, 0, 1, 1, double_type, &neues->x[0], repetition,critical);
+          ParseForParameter(verbose,FileBuffer, keyword, 0, 2, 1, double_type, &neues->x[1], repetition,critical);
+          ParseForParameter(verbose,FileBuffer, keyword, 0, 3, 1, double_type, &neues->x[2], repetition,critical);
           ParseForParameter(verbose,FileBuffer, keyword, 0, 4, 1, int_type, &neues->FixedIon, repetition,critical);
-          if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 5, 1, double_type, &neues->v.x[0], repetition,optional))
-            neues->v.x[0] = 0.;
-          if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 6, 1, double_type, &neues->v.x[1], repetition,optional))
-            neues->v.x[1] = 0.;
-          if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 7, 1, double_type, &neues->v.x[2], repetition,optional))
-            neues->v.x[2] = 0.;
+          if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 5, 1, double_type, &neues->v[0], repetition,optional))
+            neues->v[0] = 0.;
+          if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 6, 1, double_type, &neues->v[1], repetition,optional))
+            neues->v[1] = 0.;
+          if(!ParseForParameter(verbose,FileBuffer, keyword, 0, 7, 1, double_type, &neues->v[2], repetition,optional))
+            neues->v[2] = 0.;
           // here we don't care if forces are present (last in trajectories is always equal to current position)
           neues->type = elementhash[i]; // find element type
@@ -850,8 +853,8 @@
 void config::Load(const char * const filename, const string &BondGraphFileName, const periodentafel * const periode, MoleculeListClass * const &MolList)
 {
-  molecule *mol = new molecule(periode);
+  molecule *mol = World::getInstance().createMolecule();
   ifstream *file = new ifstream(filename);
   if (file == NULL) {
-    eLog() << Verbose(1) << "config file " << filename << " missing!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "config file " << filename << " missing!" << endl);
     return;
   }
@@ -965,10 +968,11 @@
   // Unit cell and magnetic field
   ParseForParameter(verbose,FileBuffer, "BoxLength", 0, 3, 3, lower_trigrid, BoxLength, 1, critical); /* Lattice->RealBasis */
-  mol->cell_size[0] = BoxLength[0];
-  mol->cell_size[1] = BoxLength[3];
-  mol->cell_size[2] = BoxLength[4];
-  mol->cell_size[3] = BoxLength[6];
-  mol->cell_size[4] = BoxLength[7];
-  mol->cell_size[5] = BoxLength[8];
+  double * const cell_size = World::getInstance().getDomain();
+  cell_size[0] = BoxLength[0];
+  cell_size[1] = BoxLength[3];
+  cell_size[2] = BoxLength[4];
+  cell_size[3] = BoxLength[6];
+  cell_size[4] = BoxLength[7];
+  cell_size[5] = BoxLength[8];
   //if (1) fprintf(stderr,"\n");
 
@@ -1060,7 +1064,7 @@
     BG = new BondGraph(IsAngstroem);
     if (BG->LoadBondLengthTable(BondGraphFileName)) {
-      Log() << Verbose(0) << "Bond length table loaded successfully." << endl;
+      DoLog(0) && (Log() << Verbose(0) << "Bond length table loaded successfully." << endl);
     } else {
-      eLog() << Verbose(1) << "Bond length table loading failed." << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << "Bond length table loading failed." << endl);
     }
   }
@@ -1088,8 +1092,8 @@
 void config::LoadOld(const char * const filename, const string &BondGraphFileName, const periodentafel * const periode, MoleculeListClass * const &MolList)
 {
-  molecule *mol = new molecule(periode);
+  molecule *mol = World::getInstance().createMolecule();
   ifstream *file = new ifstream(filename);
   if (file == NULL) {
-    eLog() << Verbose(1) << "config file " << filename << " missing!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "config file " << filename << " missing!" << endl);
     return;
   }
@@ -1106,5 +1110,5 @@
   string zeile;
   string dummy;
-  element *elementhash[128];
+  const element *elementhash[128];
   int Z = -1;
   int No = -1;
@@ -1169,10 +1173,11 @@
 
   ParseForParameter(verbose,file, "BoxLength", 0, 3, 3, lower_trigrid, BoxLength, 1, critical); /* Lattice->RealBasis */
-  mol->cell_size[0] = BoxLength[0];
-  mol->cell_size[1] = BoxLength[3];
-  mol->cell_size[2] = BoxLength[4];
-  mol->cell_size[3] = BoxLength[6];
-  mol->cell_size[4] = BoxLength[7];
-  mol->cell_size[5] = BoxLength[8];
+  double * const cell_size = World::getInstance().getDomain();
+  cell_size[0] = BoxLength[0];
+  cell_size[1] = BoxLength[3];
+  cell_size[2] = BoxLength[4];
+  cell_size[3] = BoxLength[6];
+  cell_size[4] = BoxLength[7];
+  cell_size[5] = BoxLength[8];
   if (1) fprintf(stderr,"\n");
   config::DoPerturbation = 0;
@@ -1250,7 +1255,7 @@
   BG = new BondGraph(IsAngstroem);
   if (BG->LoadBondLengthTable(BondGraphFileName)) {
-    Log() << Verbose(0) << "Bond length table loaded successfully." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Bond length table loaded successfully." << endl);
   } else {
-    Log() << Verbose(0) << "Bond length table loading failed." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Bond length table loading failed." << endl);
   }
 
@@ -1259,10 +1264,10 @@
   for (i=MAX_ELEMENTS;i--;)
     elementhash[i] = NULL;
-  Log() << Verbose(0) << "Parsing Ions ..." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Parsing Ions ..." << endl);
   No=0;
   found = 0;
   while (getline(*file,zeile,'\n')) {
     if (zeile.find("Ions_Data") == 0) {
-      Log() << Verbose(1) << "found Ions_Data...begin parsing" << endl;
+      DoLog(1) && (Log() << Verbose(1) << "found Ions_Data...begin parsing" << endl);
       found ++;
     }
@@ -1278,8 +1283,8 @@
       input >> b;     // element mass
       elementhash[No] = periode->FindElement(Z);
-      Log() << Verbose(1) << "AtomNo: " << AtomNo << "\tZ: " << Z << "\ta:" << a << "\tl:"  << l << "\b:" << b << "\tElement:" << elementhash[No] << "\t:" << endl;
+      DoLog(1) && (Log() << Verbose(1) << "AtomNo: " << AtomNo << "\tZ: " << Z << "\ta:" << a << "\tl:"  << l << "\b:" << b << "\tElement:" << elementhash[No] << "\t:" << endl);
       for(i=0;i<AtomNo;i++) {
         if (!getline(*file,zeile,'\n')) {// parse on and on
-          Log() << Verbose(2) << "Error: Too few items in ionic list of element" << elementhash[No] << "." << endl << "Exiting." << endl;
+          DoLog(2) && (Log() << Verbose(2) << "Error: Too few items in ionic list of element" << elementhash[No] << "." << endl << "Exiting." << endl);
           // return 1;
         } else {
@@ -1287,8 +1292,8 @@
         }
         istringstream input2(zeile);
-        atom *neues = new atom();
-        input2 >> neues->x.x[0]; // x
-        input2 >> neues->x.x[1]; // y
-        input2 >> neues->x.x[2]; // z
+        atom *neues = World::getInstance().createAtom();
+        input2 >> neues->x[0]; // x
+        input2 >> neues->x[1]; // y
+        input2 >> neues->x[2]; // z
         input2 >> l;
         neues->type = elementhash[No]; // find element type
@@ -1312,4 +1317,5 @@
   // bring MaxTypes up to date
   mol->CountElements();
+  const double * const cell_size = World::getInstance().getDomain();
   ofstream * const output = new ofstream(filename, ios::out);
   if (output != NULL) {
@@ -1382,7 +1388,7 @@
     *output << endl;
     *output << "BoxLength\t\t\t# (Length of a unit cell)" << endl;
-    *output << mol->cell_size[0] << "\t" << endl;
-    *output << mol->cell_size[1] << "\t" << mol->cell_size[2] << "\t" << endl;
-    *output << mol->cell_size[3] << "\t" << mol->cell_size[4] << "\t" << mol->cell_size[5] << "\t" << endl;
+    *output << cell_size[0] << "\t" << endl;
+    *output << cell_size[1] << "\t" << cell_size[2] << "\t" << endl;
+    *output << cell_size[3] << "\t" << cell_size[4] << "\t" << cell_size[5] << "\t" << endl;
     // FIXME
     *output << endl;
@@ -1428,5 +1434,5 @@
     return result;
   } else {
-    eLog() << Verbose(1) << "Cannot open output file:" << filename << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Cannot open output file:" << filename << endl);
     return false;
   }
@@ -1450,5 +1456,5 @@
     output = new ofstream(fname->str().c_str(), ios::out);
     if (output == NULL) {
-      eLog() << Verbose(1) << "Cannot open mpqc output file:" << fname << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << "Cannot open mpqc output file:" << fname << endl);
       delete(fname);
       return false;
@@ -1493,5 +1499,5 @@
     output = new ofstream(fname->str().c_str(), ios::out);
     if (output == NULL) {
-      eLog() << Verbose(1) << "Cannot open mpqc hessian output file:" << fname << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << "Cannot open mpqc hessian output file:" << fname << endl);
       delete(fname);
       return false;
@@ -1549,5 +1555,5 @@
   f = fopen(name, "w" );
   if (f == NULL) {
-    eLog() << Verbose(1) << "Cannot open pdb output file:" << name << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Cannot open pdb output file:" << name << endl);
     return false;
   }
@@ -1569,7 +1575,7 @@
              'a'+(unsigned char)(AtomNo % 26),           /* letter for chain */
              MolNo,         /* residue sequence number */
-             Walker->node->x[0],                 /* position X in Angstroem */
-             Walker->node->x[1],                 /* position Y in Angstroem */
-             Walker->node->x[2],                 /* position Z in Angstroem */
+             Walker->node->at(0),                 /* position X in Angstroem */
+             Walker->node->at(1),                 /* position Y in Angstroem */
+             Walker->node->at(2),                 /* position Z in Angstroem */
              (double)Walker->type->Valence,         /* occupancy */
              (double)Walker->type->NoValenceOrbitals,          /* temperature factor */
@@ -1604,5 +1610,5 @@
   f = fopen(name, "w" );
   if (f == NULL) {
-    eLog() << Verbose(1) << "Cannot open pdb output file:" << name << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Cannot open pdb output file:" << name << endl);
     Free(&elementNo);
     return false;
@@ -1623,7 +1629,7 @@
            'a'+(unsigned char)(AtomNo % 26),           /* letter for chain */
            0,         /* residue sequence number */
-           Walker->node->x[0],                 /* position X in Angstroem */
-           Walker->node->x[1],                 /* position Y in Angstroem */
-           Walker->node->x[2],                 /* position Z in Angstroem */
+           Walker->node->at(0),                 /* position X in Angstroem */
+           Walker->node->at(1),                 /* position Y in Angstroem */
+           Walker->node->at(2),                 /* position Z in Angstroem */
            (double)Walker->type->Valence,         /* occupancy */
            (double)Walker->type->NoValenceOrbitals,          /* temperature factor */
@@ -1641,4 +1647,5 @@
 /** Stores all atoms in a TREMOLO data input file.
  * Note that this format cannot be parsed again.
+ * Note that TREMOLO does not like Id starting at 0, but at 1. Atoms with Id 0 are discarded!
  * \param *filename name of file (without ".in" suffix!)
  * \param *mol pointer to molecule
@@ -1653,5 +1660,5 @@
   output = new ofstream(fname->str().c_str(), ios::out);
   if (output == NULL) {
-    eLog() << Verbose(1) << "Cannot open tremolo output file:" << fname << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Cannot open tremolo output file:" << fname << endl);
     delete(fname);
     return false;
@@ -1676,6 +1683,6 @@
     *output << mol->name << "\t";
     *output << 0 << "\t";
-    *output << Walker->node->x[0] << "\t" << Walker->node->x[1] << "\t" << Walker->node->x[2] << "\t";
-    *output << (double)Walker->type->Valence << "\t";
+    *output << Walker->node->at(0) << "\t" << Walker->node->at(1) << "\t" << Walker->node->at(2) << "\t";
+    *output << static_cast<double>(Walker->type->Valence) << "\t";
     *output << Walker->type->symbol << "\t";
     for (BondList::iterator runner = Walker->ListOfBonds.begin(); runner != Walker->ListOfBonds.end(); runner++)
@@ -1695,4 +1702,5 @@
 /** Stores all atoms from all molecules in a TREMOLO data input file.
  * Note that this format cannot be parsed again.
+ * Note that TREMOLO does not like Id starting at 0, but at 1. Atoms with Id 0 are discarded!
  * \param *filename name of file (without ".in" suffix!)
  * \param *MolList pointer to MoleculeListClass containing all atoms
@@ -1707,5 +1715,5 @@
   output = new ofstream(fname->str().c_str(), ios::out);
   if (output == NULL) {
-    eLog() << Verbose(1) << "Cannot open tremolo output file:" << fname << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Cannot open tremolo output file:" << fname << endl);
     delete(fname);
     return false;
@@ -1747,13 +1755,13 @@
       while (Walker->next != (*MolWalker)->end) {
         Walker = Walker->next;
-        *output << AtomNo << "\t";
+        *output << AtomNo+1 << "\t";
         *output << Walker->Name << "\t";
         *output << (*MolWalker)->name << "\t";
-        *output << MolCounter << "\t";
-        *output << Walker->node->x[0] << "\t" << Walker->node->x[1] << "\t" << Walker->node->x[2] << "\t";
+        *output << MolCounter+1 << "\t";
+        *output << Walker->node->at(0) << "\t" << Walker->node->at(1) << "\t" << Walker->node->at(2) << "\t";
         *output << (double)Walker->type->Valence << "\t";
         *output << Walker->type->symbol << "\t";
         for (BondList::iterator runner = Walker->ListOfBonds.begin(); runner != Walker->ListOfBonds.end(); runner++)
-          *output << LocalNotoGlobalNoMap[MolCounter][ (*runner)->GetOtherAtom(Walker)->nr ] << "\t";
+          *output << LocalNotoGlobalNoMap[MolCounter][ (*runner)->GetOtherAtom(Walker)->nr ]+1 << "\t";
         for(int i=Walker->ListOfBonds.size(); i < MaxNeighbours; i++)
           *output << "-\t";
@@ -1787,5 +1795,5 @@
   char filename[MAXSTRINGSIZE];
   ofstream output;
-  molecule *mol = new molecule(periode);
+  molecule *mol = World::getInstance().createMolecule();
   mol->SetNameFromFilename(ConfigFileName);
 
@@ -1898,5 +1906,5 @@
   }
 
-  delete(mol);
+  World::getInstance().destroyMolecule(mol);
 };
 
Index: src/datacreator.cpp
===================================================================
--- src/datacreator.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/datacreator.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -25,5 +25,5 @@
   output.open(name.str().c_str(), ios::out);
   if (output == NULL) {
-    Log() << Verbose(0) << "Unable to open " << name.str() << " for writing, is directory correct?" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Unable to open " << name.str() << " for writing, is directory correct?" << endl);
     return false;
   }
@@ -43,5 +43,5 @@
   output.open(name.str().c_str(), ios::app);
   if (output == NULL) {
-    Log() << Verbose(0) << "Unable to open " << name.str() << " for writing, is directory correct?" << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Unable to open " << name.str() << " for writing, is directory correct?" << endl);
     return false;
   }
@@ -63,5 +63,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum;
   output << "#Order\tFrag.No.\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
@@ -96,5 +96,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum;
   output << "#Order\tFrag.No.\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
@@ -133,5 +133,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum;
   output << "# Order\tFrag.No.\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
@@ -165,5 +165,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum;
   output << "# Order\tFrag.No.\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
@@ -198,5 +198,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum;
   output << "# AtomNo\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
@@ -244,5 +244,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum;
   output << "# AtomNo\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
@@ -281,5 +281,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false; 
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum;
   output << "# AtomNo\t" << Fragments.Header[Fragments.MatrixCounter] << endl;
@@ -321,5 +321,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false; 
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum;
   output << "# AtomNo\t";
@@ -363,5 +363,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false; 
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum;
   output << "# AtomNo\t" << Fragments.Header[ Fragments.MatrixCounter ] << endl;
@@ -393,5 +393,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum << endl;
   output << "#Order\tFrag.No.\t" << Fragment.Header[ Fragment.MatrixCounter ] << endl;
@@ -458,5 +458,5 @@
   filename << prefix << ".dat";
   if (!OpenOutputFile(output, dir, filename.str().c_str())) return false;
-  Log() << Verbose(0) << msg << endl;
+  DoLog(0) && (Log() << Verbose(0) << msg << endl);
   output << "# " << msg << ", created on " << datum;
   output << "#Order\tFrag.No.\t" << Fragment.Header[ Fragment.MatrixCounter ] << endl;
@@ -771,5 +771,5 @@
 {
   stringstream line(Force.Header[Force.MatrixCounter]);
-  char *fillcolor[5] = {"black", "red", "blue", "green", "cyan"};
+  const char *fillcolor[5] = {"black", "red", "blue", "green", "cyan"};
   string token;
 
@@ -803,5 +803,5 @@
 {
   stringstream line(Force.Header[Force.MatrixCounter]);
-  char *fillcolor[5] = {"black", "red", "blue", "green", "cyan"};
+  const char *fillcolor[5] = {"black", "red", "blue", "green", "cyan"};
   string token;
 
Index: src/defs.hpp
===================================================================
--- src/defs.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/defs.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -12,5 +12,4 @@
 #define MAX_ELEMENTS 128  //!< maximum number of elements for certain lookup tables 
 #define AtomicLengthToAngstroem  0.52917721 //!< conversion factor from atomic length/bohrradius to angstroem
-#define BONDTHRESHOLD 0.5   //!< CSD threshold in bond check which is the width of the interval whose center is the sum of the covalent radii 
 #define AtomicEnergyToKelvin 315774.67  //!< conversion factor from atomic energy to kelvin via boltzmann factor
 #define KelvinToAtomicTemperature 3.1668152e-06    //!< conversion factor for Kelvin to atomic temperature (Hartree over k_B)
@@ -32,4 +31,6 @@
 
 enum Shading { white, lightgray, darkgray, black };  //!< color in Breadth-First-Search analysis
+
+
 
 //enum CutCyclicBond { KeepBond,  SaturateBond }; //!< Saturation scheme either atom- or bondwise 
Index: src/element.cpp
===================================================================
--- src/element.cpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/element.cpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -10,14 +10,22 @@
 #include "element.hpp"
 
+using namespace std;
+
 /************************************* Functions for class element **********************************/
 
 /** Constructor of class element.
  */
-element::element() {
-  Z = -1;
-  No = -1;
-  previous = NULL;
-  next = NULL;
-  sort = NULL;
+element::element() :
+  mass(0),
+  CovalentRadius(0),
+  VanDerWaalsRadius(0),
+	Z(-1),
+	previous(NULL),
+	next(NULL),
+	sort(NULL),
+	No(-1),
+	Valence(0),
+	NoValenceOrbitals(0)
+{
 };
 
@@ -29,5 +37,5 @@
  * \param *out outstream
  */
-bool element::Output(ofstream * const out) const
+bool element::Output(ostream * const out) const
 { 
   if (out != NULL) {
@@ -44,5 +52,5 @@
  * \param NoOfAtoms total number of atom of this element type
  */
-bool element::Checkout(ofstream * const out, const int Number, const int NoOfAtoms) const
+bool element::Checkout(ostream * const out, const int Number, const int NoOfAtoms) const
 { 
   if (out != NULL) {
@@ -52,2 +60,10 @@
     return false;
 };
+
+atomicNumber_t element::getNumber() const{
+  return Z;
+}
+
+string element::getSymbol() const{
+  return string(symbol);
+}
Index: src/element.hpp
===================================================================
--- src/element.hpp	(revision cee0a17a1e62832f65ac6bb6775b3263ef3122d0)
+++ src/element.hpp	(revision 498c519f5f85d12aba5dc98b7adde3d2c7f45c5b)
@@ -9,6 +9,4 @@
 #define ELEMENT_HPP_
 
-using namespace std;
-
 /*********************************************** includes ***********************************/
 
@@ -19,6 +17,8 @@
 
 #include <iostream>
+#include <string>
 
 #include "defs.hpp"
+#include "types.hpp"
 
 /********************************************** declarations *******************************/
@@ -50,7 +50,11 @@
   ~element();
 
+  // accessor functions
+  atomicNumber_t getNumber() const;
+  std::string getSymbol() const;
+
   //> print element entries to screen
-  bool Output(ofstream * const out) const;
-  bool Checkout(ofstream * const out, const int No, const int NoOfAtoms) const;
+  bool Output(std::ostream * const out) const;
+  bool Checkout(std::ostream * const out, const int No, const int NoOfAtoms) const;
 
   private:
